#
# map3d3.rb
#   $Id: map3d3.rb,v 1.1 2000/11/18 19:03:39 keiko Exp $
#


require "narray"
require "numru/dcl"
include NumRu::DCL
include Math

nx = 16
ny = 16
xmin = 120
xmax = 150
ymin = 20
ymax = 50
fact = 0.21
u = NArray.sfloat(nx, ny)
v = NArray.sfloat(nx, ny)
alon = NArray.sfloat(nx)
alat = NArray.sfloat(ny)

#-- data ---
for i in 0..nx-1
  alon[i] = xmin + (xmax-xmin)*i/(nx-1).to_f
end
for j in 0..ny-1
  alat[j] = ymin + (ymax-ymin)*j/(ny-1).to_f
end

for j in 0..ny-1
  for i in 0..nx-1
    u[i,j] =   (j-(ny-1)/2.0) * fact
    v[i,j] = - (i-(nx-1)/2.0) * fact
  end
end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
gropn iws

grfrm
sglset('LCLIP', true)

grswnd(xmin, xmax, ymin, ymax)
grsvpt(0.1, 0.9, 0.1, 0.9)
grstrn(10)
umpfit
grstrf

slpvpr(3)
umrset('DGRIDMJ', 10.0)
umrset('DGRIDMN', 2.0)
umpmap('coast_world')
umpglb

sgslai(3)
for j in 0..ny-1
  for i in 0..nx-1
    sglau(alon[i], alat[j], alon[i]+u[i,j], alat[j]+v[i,j])
  end
end

grcls

